const app = getApp()
import WxValidate from '../../utils/wxValidate'
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '赛程信息', leftArrow: true, useBar: false },
        id: '',
        form: {},
        // 赛事信息
        matchList: [],
        // 组别
        groupingList: [],
        //组内项目
        projectList: [],
        // 分组数据
        raceTeamList: [],
        // 组成员
        personList: [],
        // 比赛场地
        groundList: [],
        // 裁判信息
        refereeList: [],
    },
    initValidate() {
        const rules = { match_id: { required: true }, grouping_id: { required: true }, project_id: { required: true }, team_id: { required: true }, player_one: { required: true }, player_two: { required: true }, ground_id: { required: true }, referee_id: { required: true }, start_date: { required: true }, start_time: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { match_id: { required: '请选择赛事名称', }, grouping_id: { required: '请选择赛事组别', }, project_id: { required: '请选择组内项目', }, team_id: { required: '请选择赛程分组', }, player_one: { required: '请选择选手一', }, player_two: { required: '请选择选手二', }, ground_id: { required: '请选择比赛场地', }, referee_id: { required: '请选择裁判', }, start_date: { required: '请选择比赛日期', }, start_time: { required: '请选择比赛时间', } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    back(e) { wx.navigateBack({ delta: 1 }) },
    // 选择赛事
    matchChange: function (e) {
        const that = this;
        let data = that.data.matchList[e.detail.value];
        if (data) {
            that.setData({ 'form.match_id': data._id });
            that.setData({ 'form.match_name': data.name });
            if (data.grouping && data.grouping.length > 0) {
                that.setData({ groupingList: data.grouping })
            }
        }
    },
    // 选择赛事组别
    grpupChange: async function (e) {
        const that = this;
        let data = that.data.groupingList[e.detail.value];
        if (data) {
            that.setData({ 'form.grouping_id': data._id });
            that.setData({ 'form.grouping_name': data.name });
            if (data.project && data.project.length > 0) {
                let projectList = [];
                for (const val of data.project) {
                    const arr = await app.$get(`/newCourt/api/matchProject/${val}`)
                    if (arr.errcode == '0') projectList.push(arr.data);
                    that.setData({ projectList: projectList })
                }
            }
        }
    },
    // 选择组内项目
    projectChange: function (e) {
        const that = this;
        let data = that.data.projectList[e.detail.value];
        if (data) {
            that.setData({ 'form.project_id': data._id });
            that.setData({ 'form.project_name': data.name });
            that.setData({ 'form.type': data.type });
            // 查询赛事，组别，项目，分组数据
            that.searchTeam()
        }
    },
    // 查询分组数据
    searchTeam: async function () {
        const that = this;
        let form = that.data.form;
        let info = { match_id: form.match_id, grouping_id: form.grouping_id, project_id: form.project_id }
        const arr = await app.$get(`/newCourt/api/raceTeam`, { ...info });
        if (arr.errcode == '0') { that.setData({ raceTeamList: arr.data }); }
    },
    // 选择赛事分组
    teamChange: function (e) {
        const that = this;
        let data = that.data.raceTeamList[e.detail.value];
        if (data) {
            that.setData({ 'form.team_id': data._id });
            that.setData({ 'form.team_name': data.name });
            if (data.person && data.person.length > 0) { that.setData({ personList: data.person }) }
        }
    },
    // 选择选手一
    playeroneChange: function (e) {
        const that = this;
        let data = that.data.personList[e.detail.value];
        if (data) {
            that.setData({ 'form.player_one': data.openid || data.team_id });
            that.setData({ 'form.player_one_name': data.name || data.names });
        }
    },
    // 选择选手二
    playertwoChange: function (e) {
        const that = this;
        const form = that.data.form;
        let data = that.data.personList[e.detail.value];
        if (data && data.openid != form.player_one) {
            that.setData({ 'form.player_two': data.openid || data.team_id });
            that.setData({ 'form.player_two_name': data.name || data.names });
        } else {
            wx.showToast({ title: `选手相同`, icon: 'error', duration: 2000 })
        }
    },
    // 比赛场地
    groundChange: function (e) {
        const that = this;
        let data = that.data.groundList[e.detail.value]
        if (data) {
            that.setData({ 'form.ground_id': data._id });
            that.setData({ 'form.ground_name': data.name });
            if (data.referee_id) {
                let user = that.data.refereeList.find((i) => i.openid == data.referee_id);
                if (user) {
                    that.setData({ 'form.referee_id': user.openid });
                    that.setData({ 'form.referee_name': user.name });
                }
            } else {
                that.setData({ 'form.referee_id': '' });
                that.setData({ 'form.referee_name': '' });
            }
        }
    },
    // 裁判
    refereeChange: function (e) {
        const that = this;
        let data = that.data.refereeList[e.detail.value];
        if (data) {
            that.setData({ 'form.referee_id': data.openid });
            that.setData({ 'form.referee_name': data.name });
        }
    },
    // 比赛日期
    startdateChange: function (e) {
        const that = this;
        that.setData({ 'form.start_date': e.detail.value })
    },
    // 比赛时间
    starttimeChange: function (e) {
        const that = this;
        that.setData({ 'form.start_time': e.detail.value })
    },
    // 提交保存
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            params.match_time = params.start_date + '-' + params.start_time
            let arr;
            if (that.data.id) { arr = await app.$post(`/newCourt/api/race/${that.data.id}`, params); }
            else { arr = await app.$post(`/newCourt/api/race`, params); }
            if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
            else wx.showToast({ title: `${arr.errmsg}`, icon: 'error', duration: 2000 })
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        that.setData({ id: options.id || '' });
        //验证规则函数
        that.initValidate();
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                let arr;
                // 数据信息
                if (that.data.id) {
                    arr = await app.$get(`/newCourt/api/race/${that.data.id}`);
                    if (arr.errcode == '0') {
                        arr.data.start_date = arr.data.match_time.slice(0, 10);
                        arr.data.start_time = arr.data.match_time.slice(11, arr.data.match_time.length);
                        that.setData({ form: arr.data })
                    }
                }
                // 比赛信息
                arr = await app.$get(`/newCourt/api/match`, { status: '0' });//2
                if (arr.errcode == '0') { that.setData({ matchList: arr.data }) }
                // 比赛场地
                arr = await app.$get(`/newCourt/api/ground`, { is_use: '0' });
                if (arr.errcode == '0') { that.setData({ groundList: arr.data }) }
                // 裁判信息
                arr = await app.$get(`/newCourt/api/user`, { type: '1' });
                if (arr.errcode == '0') { that.setData({ refereeList: arr.data }) };

            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () { },


    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})